version: '3.8'
services:
  traefik:
    image: traefik:v3.0
    container_name: ${VM_ID:-olip}-traefik
    restart: unless-stopped
    command:
      - '--log.level=DEBUG'
      - '--api.insecure=true'
      - '--providers.docker=true'
      - '--providers.docker.exposedbydefault=false'
      - '--entrypoints.web.address=:80'
      - '--entrypoints.websecure.address=:443'
      - '--entrypoints.websecure.http.redirections.entrypoint.to=web'
      - '--entrypoints.websecure.http.redirections.entrypoint.scheme=http'
    ports:
      - '80:80'
      - '443:443'
      - '8080:8080'
    volumes:
      - /var/run/docker.sock:/var/run/docker.sock:ro
      - ./traefik_volume/letsencrypt:/letsencrypt
  elasticsearch:
    image: docker.elastic.co/elasticsearch/elasticsearch:7.13.2
    container_name: olip_elasticsearch
    restart: always
    environment:
      - discovery.type=single-node
    deploy:
      resources:
        limits:
          memory: '1GB'
    volumes:
      - esdata:/usr/share/elasticsearch/data
    ports:
      - 9200:9200
  olip-api:
    build: .
    container_name: olip-api
    restart: unless-stopped
    ports:
      - 3000:80
    env_file:
      - .env
    volumes:
      - /var/run/docker.sock:/var/run/docker.sock:ro
      - ./olip/databases:/app/data/databases
      - ./olip/applications:/app/data/applications
      - ${CONTENTS_VOLUME}/images:/app/data/static/images
      - ${CONTENTS_VOLUME}/items:/app/data/static/items
      - ${CONTENTS_VOLUME}/item_thumbnails:/app/data/static/item_thumbnails
      - ${CONTENTS_VOLUME}/playlist_thumbnails:/app/data/static/playlist_thumbnails
      - /olip-files:/olip-files
    labels:
      - 'traefik.enable=true'
      - 'traefik.http.routers.${VM_ID:-olip}-olip-api.rule=Host(`api.${OLIP_HOST:-api.ideascube.io}`)'
      - 'traefik.http.routers.${VM_ID:-olip}-olip-api.tls=${TLS_ENABLED:-false}'
      - 'traefik.http.routers.${VM_ID:-olip}-olip-api.tls.certresolver=${OLIP_RESOLVER_ID}'
      - 'traefik.http.services.${VM_ID:-olip}-olip-api.loadbalancer.server.port=80'
  olip-dashboard:
    image: registry.gitlab.com/bibliosansfrontieres/olip-ng/olip-dashboard:latest
    container_name: olip-dashboard
    restart: unless-stopped
    ports:
      - 3001:80
    env_file:
      - .dashboard.env
    labels:
      - 'traefik.enable=true'
      - 'traefik.http.routers.${VM_ID:-olip}-olip-dashboard.rule=Host(`${OLIP_HOST:-ideascube.io}`)'
      - 'traefik.http.routers.${VM_ID:-olip}-olip-dashboard.tls=${TLS_ENABLED:-false}'
      - 'traefik.http.routers.${VM_ID:-olip}-olip-dashboard.tls.certresolver=${OLIP_RESOLVER_ID}'
      - 'traefik.http.services.${VM_ID:-olip}-olip-dashboard.loadbalancer.server.port=80'

volumes:
  esdata:
